﻿
; arbitrary length integer

EnableExplicit

CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
  MessageRequester("Fehler" ,"Compiler -x86 muss eingestellt sein.")
  End
CompilerEndIf

; LPCSTR  = long
; CHAR    = byte
; .p-ascii, .a : das sind hier Pointer, der (Pseudo-)Typ beschreibt den Inhalt der Speicherzellen an dem Ort
PrototypeC  zzadd(ret.a, Wert1.p-ascii, Wert2.p-ascii) ; Addition        ret = Wert1 + Wert2
PrototypeC  zzsub(ret.a, Wert1.p-ascii, Wert2.p-ascii) ; Subtraktion
PrototypeC  zzmul(ret.a, Wert1.p-ascii, Wert2.p-ascii) ; Multiplikation
PrototypeC  zzdiv(ret.a, Wert1.p-ascii, Wert2.p-ascii) ; Division
PrototypeC  zzrem(ret.a, Wert1.p-ascii, Wert2.p-ascii) ; Modulo
PrototypeC  zzpom(ret.a, Wert1.p-ascii, Wert2.p-ascii, Wert3.p-ascii)  ; Potenzieren-Modulo   x = w1^e % w3 (e kann negative sein)
PrototypeC  zzgcd(ret.a, Wert1.p-ascii, Wert2.p-ascii)                 ; ggT
PrototypeC  zzeea(rd.a, rs.a, rt.a, Wa.p-ascii, Wb.p-ascii) ; Extended Euclidean Algorithm  d = gcd(a, b) = a*s + b*t
PrototypeC  zzsqr(ret.a, Wert1.p-ascii)        ; Quadrat  ret = w1*w1
PrototypeC  zzsro(ret.a, Wert1.p-ascii)        ; Quadratwurzel  ret = floor(a^{1/2}) (a >= 0)
PrototypeC  zzpri(ret.a, len.l)                ; Primzahl erzeugen
PrototypeC  zznpr(ret.a, Wert1.p-ascii)        ; nächsthöhere Primzahl  ret = smallest prime >= w1.  Uses ProbPrime with NumTrials.
PrototypeC  zzpwr(ret.a, Wert1.p-ascii, e.l)   ; Potenzieren  x = a^e (e >= 0)
PrototypeC  zzsee(Wert1.p-ascii)               ; setzt den Startwert für zzrnd  (Seed)
PrototypeC  zzrnd(ret.a, len.l)                ; Zufallszahl mit der Länge 2^len-1 erzeugen
PrototypeC  zzcrt(ret1.a, ret2.a, Wert1.p-ascii, Wert2.p-ascii) ; Incrementaler Chinesischer Restsatz
PrototypeC  zzrec(ret1.a, ret2.a, Wert1.p-ascii, Wert2.p-ascii, Wert3.p-ascii, Wert4.p-ascii) ; Rational Reconstruction
PrototypeC  zzbtn(ret.a, byte.a, n.l)          ; Byte to Number   x = sum(byte[i]*256^i, i=0..n-1)   (byte[0] = LSB)
PrototypeC  zzntb(ret.a, Wert1.p-ascii, n.l)           ; Number to Byte
PrototypeC  zzand(ret.a, Wert1.p-ascii, Wert2.p-ascii) ; bitwise And
PrototypeC  zzior(ret.a, Wert1.p-ascii, Wert2.p-ascii) ; bitwise Or
PrototypeC  zzxor(ret.a, Wert1.p-ascii, Wert2.p-ascii) ; bitwise Xor
PrototypeC  zznob(Wert1.p-ascii)               ; Anzahl der Bits
PrototypeC  zzham(Wert1.p-ascii)               ; Hamming Gewicht   (die Anzahl der von "0" verschiedenen Zeichen)
PrototypeC  zzlsh(ret.a, Wert1.p-ascii, sh.l)  ; links schieben
PrototypeC  zzrsh(ret.a, Wert1.p-ascii, sh.l)  ; rechts schieben (mit Nullen aufgefüllt - Vorzeichen bleibt erhalten)

Global zzadd.zzadd
Global zzsub.zzsub
Global zzmul.zzmul
Global zzdiv.zzdiv
Global zzrem.zzrem
Global zzpom.zzpom
Global zzgcd.zzgcd
Global zzeea.zzeea
Global zzsqr.zzsqr
Global zzsro.zzsro
Global zzpri.zzpri
Global zznpr.zznpr
Global zzpwr.zzpwr
Global zzsee.zzsee
Global zzrnd.zzrnd
Global zzcrt.zzcrt
Global zzrec.zzrec
Global zzbtn.zzbtn
Global zzntb.zzntb
Global zzand.zzand
Global zzior.zzior
Global zzxor.zzxor
Global zznob.zznob
Global zzham.zzham
Global zzlsh.zzlsh
Global zzrsh.zzrsh

Procedure.l ALI_LoadDLL()
  Protected hDLL.l
  hDLL = OpenLibrary(#PB_Any, "ALI.dll")
  If hDLL <> 0
    zzadd = GetFunction(hDLL, "zzadd")
    zzsub = GetFunction(hDLL, "zzsub")
    zzmul = GetFunction(hDLL, "zzmul")
    zzdiv = GetFunction(hDLL, "zzdiv")
    zzrem = GetFunction(hDLL, "zzrem")  ; Modulo
    zzpom = GetFunction(hDLL, "zzpom")  ; x = a^e % n (e kann negativ sein)   RSA-ver- und entschlüsseln
    zzgcd = GetFunction(hDLL, "zzgcd")  ; größter gemeinsamer Teiler
    zzeea = GetFunction(hDLL, "zzeea")  ; Extended Euclidean Algorithm  d = gcd(a, b) = a*s + b*t
    zzsqr = GetFunction(hDLL, "zzsqr")  ; ret = w1*w1
    zzsro = GetFunction(hDLL, "zzsro")  ; ret = floor(a^{1/2}) (a >= 0)
    zzpri = GetFunction(hDLL, "zzpri")  ; Prime
    zznpr = GetFunction(hDLL, "zznpr")  ; ret = smallest prime >= w1.  Uses ProbPrime with NumTrials.
    zzpwr = GetFunction(hDLL, "zzpwr")  ; x = a^e (e >= 0)
    zzsee = GetFunction(hDLL, "zzsee")  ; setzt den Startwert für zzrnd  (Seed)
    zzrnd = GetFunction(hDLL, "zzrnd")  ; Zufallszahl mit der Länge 2^len-1 erzeugen
    zzcrt = GetFunction(hDLL, "zzcrt")  ; Increnentaler Chinesischer Restsatz
    zzrec = GetFunction(hDLL, "zzrec")  ; Rational Reconstruction
    zzbtn = GetFunction(hDLL, "zzbtn")  ; Byte to Number   x = sum(byte[i]*256^i, i=0..n-1)   (byte[0] = LSB)
    zzntb = GetFunction(hDLL, "zzntb")  ; Number to Byte   (byte[0] = LSB)
    zzand = GetFunction(hDLL, "zzand")  ; bitwise And
    zzior = GetFunction(hDLL, "zzior")  ; bitwise Or
    zzxor = GetFunction(hDLL, "zzxor")  ; bitwise Xor
    zznob = GetFunction(hDLL, "zznob")  ; number of bits
    zzham = GetFunction(hDLL, "zzham")  ; Hamming Gewicht (die Anzahl der von "0" verschiedenen Zeichen)
    zzlsh = GetFunction(hDLL, "zzlsh")  ; links schieben
    zzrsh = GetFunction(hDLL, "zzrsh")  ; rechts schieben (mit Nullen aufgefüllt - Vorzeichen bleibt erhalten)
    If zzadd And zzsub And zzmul And zzdiv And zzrem And zzpom And zzgcd And zzeea And zzsqr And zzsro And zzpri And 
       zznpr And zzpwr And zznob And zzham And zzlsh And zzrsh And zzsee And zzrnd And zzcrt And zzrec And zzbtn And 
       zzntb And zzand And zzior And zzxor
      ProcedureReturn hDLL
    EndIf
  EndIf
  ProcedureReturn #False
EndProcedure

Procedure ALI_CloseDLL(hDLL.l)
  If IsLibrary(hDLL)
    CloseLibrary(hDLL)
  EndIf 
EndProcedure
  

; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 84
; Folding = -
; EnableXP
; Executable = C:\CProg\NTL\DLLtest\bin\Release\DLLtest.exe
; Compiler = PureBasic 5.70 LTS (Windows - x86)